Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1270)
+++ lemon/full_graph.h	(revision 834)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -204,5 +204,5 @@
     /// \brief Returns the node with the given index.
     ///
-    /// Returns the node with the given index. Since this structure is
+    /// Returns the node with the given index. Since this structure is 
     /// completely static, the nodes can be indexed with integers from
     /// the range <tt>[0..nodeNum()-1]</tt>.
@@ -213,5 +213,5 @@
     /// \brief Returns the index of the given node.
     ///
-    /// Returns the index of the given node. Since this structure is
+    /// Returns the index of the given node. Since this structure is 
     /// completely static, the nodes can be indexed with integers from
     /// the range <tt>[0..nodeNum()-1]</tt>.
@@ -583,5 +583,5 @@
     /// \brief Returns the node with the given index.
     ///
-    /// Returns the node with the given index. Since this structure is
+    /// Returns the node with the given index. Since this structure is 
     /// completely static, the nodes can be indexed with integers from
     /// the range <tt>[0..nodeNum()-1]</tt>.
@@ -592,5 +592,5 @@
     /// \brief Returns the index of the given node.
     ///
-    /// Returns the index of the given node. Since this structure is
+    /// Returns the index of the given node. Since this structure is 
     /// completely static, the nodes can be indexed with integers from
     /// the range <tt>[0..nodeNum()-1]</tt>.
@@ -622,458 +622,4 @@
   };
 
-  class FullBpGraphBase {
-
-  protected:
-
-    int _red_num, _blue_num;
-    int _node_num, _edge_num;
-
-  public:
-
-    typedef FullBpGraphBase Graph;
-
-    class Node;
-    class Arc;
-    class Edge;
-
-    class Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Node(int id) { _id = id;}
-
-    public:
-      Node() {}
-      Node (Invalid) { _id = -1; }
-      bool operator==(const Node& node) const {return _id == node._id;}
-      bool operator!=(const Node& node) const {return _id != node._id;}
-      bool operator<(const Node& node) const {return _id < node._id;}
-    };
-
-    class RedNode : public Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      explicit RedNode(int pid) : Node(pid) {}
-
-    public:
-      RedNode() {}
-      RedNode(const RedNode& node) : Node(node) {}
-      RedNode(Invalid) : Node(INVALID){}
-    };
-
-    class BlueNode : public Node {
-      friend class FullBpGraphBase;
-    protected:
-
-      explicit BlueNode(int pid) : Node(pid) {}
-
-    public:
-      BlueNode() {}
-      BlueNode(const BlueNode& node) : Node(node) {}
-      BlueNode(Invalid) : Node(INVALID){}
-    };
-
-    class Edge {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Edge(int id) { _id = id;}
-
-    public:
-      Edge() {}
-      Edge (Invalid) { _id = -1; }
-      bool operator==(const Edge& arc) const {return _id == arc._id;}
-      bool operator!=(const Edge& arc) const {return _id != arc._id;}
-      bool operator<(const Edge& arc) const {return _id < arc._id;}
-    };
-
-    class Arc {
-      friend class FullBpGraphBase;
-    protected:
-
-      int _id;
-      explicit Arc(int id) { _id = id;}
-
-    public:
-      operator Edge() const {
-        return _id != -1 ? edgeFromId(_id / 2) : INVALID;
-      }
-
-      Arc() {}
-      Arc (Invalid) { _id = -1; }
-      bool operator==(const Arc& arc) const {return _id == arc._id;}
-      bool operator!=(const Arc& arc) const {return _id != arc._id;}
-      bool operator<(const Arc& arc) const {return _id < arc._id;}
-    };
-
-
-  protected:
-
-    FullBpGraphBase()
-      : _red_num(0), _blue_num(0), _node_num(0), _edge_num(0) {}
-
-    void construct(int redNum, int blueNum) {
-      _red_num = redNum; _blue_num = blueNum;
-      _node_num = redNum + blueNum; _edge_num = redNum * blueNum;
-    }
-
-  public:
-
-    typedef True NodeNumTag;
-    typedef True EdgeNumTag;
-    typedef True ArcNumTag;
-
-    int nodeNum() const { return _node_num; }
-    int redNum() const { return _red_num; }
-    int blueNum() const { return _blue_num; }
-    int edgeNum() const { return _edge_num; }
-    int arcNum() const { return 2 * _edge_num; }
-
-    int maxNodeId() const { return _node_num - 1; }
-    int maxRedId() const { return _red_num - 1; }
-    int maxBlueId() const { return _blue_num - 1; }
-    int maxEdgeId() const { return _edge_num - 1; }
-    int maxArcId() const { return 2 * _edge_num - 1; }
-
-    bool red(Node n) const { return n._id < _red_num; }
-    bool blue(Node n) const { return n._id >= _red_num; }
-
-    static RedNode asRedNodeUnsafe(Node n) { return RedNode(n._id); }
-    static BlueNode asBlueNodeUnsafe(Node n) { return BlueNode(n._id); }
-
-    Node source(Arc a) const {
-      if (a._id & 1) {
-        return Node((a._id >> 1) % _red_num);
-      } else {
-        return Node((a._id >> 1) / _red_num + _red_num);
-      }
-    }
-    Node target(Arc a) const {
-      if (a._id & 1) {
-        return Node((a._id >> 1) / _red_num + _red_num);
-      } else {
-        return Node((a._id >> 1) % _red_num);
-      }
-    }
-
-    RedNode redNode(Edge e) const {
-      return RedNode(e._id % _red_num);
-    }
-    BlueNode blueNode(Edge e) const {
-      return BlueNode(e._id / _red_num + _red_num);
-    }
-
-    static bool direction(Arc a) {
-      return (a._id & 1) == 1;
-    }
-
-    static Arc direct(Edge e, bool d) {
-      return Arc(e._id * 2 + (d ? 1 : 0));
-    }
-
-    void first(Node& node) const {
-      node._id = _node_num - 1;
-    }
-
-    static void next(Node& node) {
-      --node._id;
-    }
-
-    void first(RedNode& node) const {
-      node._id = _red_num - 1;
-    }
-
-    static void next(RedNode& node) {
-      --node._id;
-    }
-
-    void first(BlueNode& node) const {
-      if (_red_num == _node_num) node._id = -1;
-      else node._id = _node_num - 1;
-    }
-
-    void next(BlueNode& node) const {
-      if (node._id == _red_num) node._id = -1;
-      else --node._id;
-    }
-
-    void first(Arc& arc) const {
-      arc._id = 2 * _edge_num - 1;
-    }
-
-    static void next(Arc& arc) {
-      --arc._id;
-    }
-
-    void first(Edge& arc) const {
-      arc._id = _edge_num - 1;
-    }
-
-    static void next(Edge& arc) {
-      --arc._id;
-    }
-
-    void firstOut(Arc &a, const Node& v) const {
-      if (v._id < _red_num) {
-        a._id = 2 * (v._id + _red_num * (_blue_num - 1)) + 1;
-      } else {
-        a._id = 2 * (_red_num - 1 + _red_num * (v._id - _red_num));
-      }
-    }
-    void nextOut(Arc &a) const {
-      if (a._id & 1) {
-        a._id -= 2 * _red_num;
-        if (a._id < 0) a._id = -1;
-      } else {
-        if (a._id % (2 * _red_num) == 0) a._id = -1;
-        else a._id -= 2;
-      }
-    }
-
-    void firstIn(Arc &a, const Node& v) const {
-      if (v._id < _red_num) {
-        a._id = 2 * (v._id + _red_num * (_blue_num - 1));
-      } else {
-        a._id = 2 * (_red_num - 1 + _red_num * (v._id - _red_num)) + 1;
-      }
-    }
-    void nextIn(Arc &a) const {
-      if (a._id & 1) {
-        if (a._id % (2 * _red_num) == 1) a._id = -1;
-        else a._id -= 2;
-      } else {
-        a._id -= 2 * _red_num;
-        if (a._id < 0) a._id = -1;
-      }
-    }
-
-    void firstInc(Edge &e, bool& d, const Node& v) const {
-      if (v._id < _red_num) {
-        d = true;
-        e._id = v._id + _red_num * (_blue_num - 1);
-      } else {
-        d = false;
-        e._id = _red_num - 1 + _red_num * (v._id - _red_num);
-      }
-    }
-    void nextInc(Edge &e, bool& d) const {
-      if (d) {
-        e._id -= _red_num;
-        if (e._id < 0) e._id = -1;
-      } else {
-        if (e._id % _red_num == 0) e._id = -1;
-        else --e._id;
-      }
-    }
-
-    static int id(const Node& v) { return v._id; }
-    int id(const RedNode& v) const { return v._id; }
-    int id(const BlueNode& v) const { return v._id - _red_num; }
-    static int id(Arc e) { return e._id; }
-    static int id(Edge e) { return e._id; }
-
-    static Node nodeFromId(int id) { return Node(id);}
-    static Arc arcFromId(int id) { return Arc(id);}
-    static Edge edgeFromId(int id) { return Edge(id);}
-
-    bool valid(Node n) const {
-      return n._id >= 0 && n._id < _node_num;
-    }
-    bool valid(Arc a) const {
-      return a._id >= 0 && a._id < 2 * _edge_num;
-    }
-    bool valid(Edge e) const {
-      return e._id >= 0 && e._id < _edge_num;
-    }
-
-    RedNode redNode(int index) const {
-      return RedNode(index);
-    }
-
-    int index(RedNode n) const {
-      return n._id;
-    }
-
-    BlueNode blueNode(int index) const {
-      return BlueNode(index + _red_num);
-    }
-
-    int index(BlueNode n) const {
-      return n._id - _red_num;
-    }
-
-    void clear() {
-      _red_num = 0; _blue_num = 0;
-      _node_num = 0; _edge_num = 0;
-    }
-
-    Edge edge(const Node& u, const Node& v) const {
-      if (u._id < _red_num) {
-        if (v._id < _red_num) {
-          return Edge(-1);
-        } else {
-          return Edge(u._id + _red_num * (v._id - _red_num));
-        }
-      } else {
-        if (v._id < _red_num) {
-          return Edge(v._id + _red_num * (u._id - _red_num));
-        } else {
-          return Edge(-1);
-        }
-      }
-    }
-
-    Arc arc(const Node& u, const Node& v) const {
-      if (u._id < _red_num) {
-        if (v._id < _red_num) {
-          return Arc(-1);
-        } else {
-          return Arc(2 * (u._id + _red_num * (v._id - _red_num)) + 1);
-        }
-      } else {
-        if (v._id < _red_num) {
-          return Arc(2 * (v._id + _red_num * (u._id - _red_num)));
-        } else {
-          return Arc(-1);
-        }
-      }
-    }
-
-    typedef True FindEdgeTag;
-    typedef True FindArcTag;
-
-    Edge findEdge(Node u, Node v, Edge prev = INVALID) const {
-      return prev != INVALID ? INVALID : edge(u, v);
-    }
-
-    Arc findArc(Node s, Node t, Arc prev = INVALID) const {
-      return prev != INVALID ? INVALID : arc(s, t);
-    }
-
-  };
-
-  typedef BpGraphExtender<FullBpGraphBase> ExtendedFullBpGraphBase;
-
-  /// \ingroup graphs
-  ///
-  /// \brief An undirected full bipartite graph class.
-  ///
-  /// FullBpGraph is a simple and fast implmenetation of undirected
-  /// full bipartite graphs. It contains an edge between every
-  /// red-blue pairs of nodes, therefore the number of edges is
-  /// <tt>nr*nb</tt>.  This class is completely static and it needs
-  /// constant memory space.  Thus you can neither add nor delete
-  /// nodes or edges, however the structure can be resized using
-  /// resize().
-  ///
-  /// This type fully conforms to the \ref concepts::BpGraph "BpGraph concept".
-  /// Most of its member functions and nested classes are documented
-  /// only in the concept class.
-  ///
-  /// This class provides constant time counting for nodes, edges and arcs.
-  ///
-  /// \sa FullGraph
-  class FullBpGraph : public ExtendedFullBpGraphBase {
-  public:
-
-    typedef ExtendedFullBpGraphBase Parent;
-
-    /// \brief Default constructor.
-    ///
-    /// Default constructor. The number of nodes and edges will be zero.
-    FullBpGraph() { construct(0, 0); }
-
-    /// \brief Constructor
-    ///
-    /// Constructor.
-    /// \param redNum The number of the red nodes.
-    /// \param blueNum The number of the blue nodes.
-    FullBpGraph(int redNum, int blueNum) { construct(redNum, blueNum); }
-
-    /// \brief Resizes the graph
-    ///
-    /// This function resizes the graph. It fully destroys and
-    /// rebuilds the structure, therefore the maps of the graph will be
-    /// reallocated automatically and the previous values will be lost.
-    void resize(int redNum, int blueNum) {
-      Parent::notifier(Arc()).clear();
-      Parent::notifier(Edge()).clear();
-      Parent::notifier(Node()).clear();
-      Parent::notifier(BlueNode()).clear();
-      Parent::notifier(RedNode()).clear();
-      construct(redNum, blueNum);
-      Parent::notifier(RedNode()).build();
-      Parent::notifier(BlueNode()).build();
-      Parent::notifier(Node()).build();
-      Parent::notifier(Edge()).build();
-      Parent::notifier(Arc()).build();
-    }
-
-    using Parent::redNode;
-    using Parent::blueNode;
-
-    /// \brief Returns the red node with the given index.
-    ///
-    /// Returns the red node with the given index. Since this
-    /// structure is completely static, the red nodes can be indexed
-    /// with integers from the range <tt>[0..redNum()-1]</tt>.
-    /// \sa redIndex()
-    RedNode redNode(int index) const { return Parent::redNode(index); }
-
-    /// \brief Returns the index of the given red node.
-    ///
-    /// Returns the index of the given red node. Since this structure
-    /// is completely static, the red nodes can be indexed with
-    /// integers from the range <tt>[0..redNum()-1]</tt>.
-    ///
-    /// \sa operator()()
-    int index(RedNode node) const { return Parent::index(node); }
-
-    /// \brief Returns the blue node with the given index.
-    ///
-    /// Returns the blue node with the given index. Since this
-    /// structure is completely static, the blue nodes can be indexed
-    /// with integers from the range <tt>[0..blueNum()-1]</tt>.
-    /// \sa blueIndex()
-    BlueNode blueNode(int index) const { return Parent::blueNode(index); }
-
-    /// \brief Returns the index of the given blue node.
-    ///
-    /// Returns the index of the given blue node. Since this structure
-    /// is completely static, the blue nodes can be indexed with
-    /// integers from the range <tt>[0..blueNum()-1]</tt>.
-    ///
-    /// \sa operator()()
-    int index(BlueNode node) const { return Parent::index(node); }
-
-    /// \brief Returns the edge which connects the given nodes.
-    ///
-    /// Returns the edge which connects the given nodes.
-    Edge edge(const Node& u, const Node& v) const {
-      return Parent::edge(u, v);
-    }
-
-    /// \brief Returns the arc which connects the given nodes.
-    ///
-    /// Returns the arc which connects the given nodes.
-    Arc arc(const Node& u, const Node& v) const {
-      return Parent::arc(u, v);
-    }
-
-    /// \brief Number of nodes.
-    int nodeNum() const { return Parent::nodeNum(); }
-    /// \brief Number of red nodes.
-    int redNum() const { return Parent::redNum(); }
-    /// \brief Number of blue nodes.
-    int blueNum() const { return Parent::blueNum(); }
-    /// \brief Number of arcs.
-    int arcNum() const { return Parent::arcNum(); }
-    /// \brief Number of edges.
-    int edgeNum() const { return Parent::edgeNum(); }
-  };
-
 
 } //namespace lemon
Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 1336)
+++ lemon/glpk.cc	(revision 793)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -39,6 +39,6 @@
     glp_copy_prob(lp, other.lp, GLP_ON);
     glp_create_index(lp);
-    _rows = other._rows;
-    _cols = other._cols;
+    rows = other.rows;
+    cols = other.cols;
     messageLevel(MESSAGE_NOTHING);
   }
@@ -60,5 +60,5 @@
   }
 
-  int GlpkBase::_addRow(Value lo, ExprIterator b,
+  int GlpkBase::_addRow(Value lo, ExprIterator b, 
                         ExprIterator e, Value up) {
     int i = glp_add_rows(lp, 1);
@@ -69,9 +69,9 @@
       } else {
         glp_set_row_bnds(lp, i, GLP_UP, lo, up);
-      }
+      }    
     } else {
       if (up == INF) {
         glp_set_row_bnds(lp, i, GLP_LO, lo, up);
-      } else if (lo != up) {
+      } else if (lo != up) {        
         glp_set_row_bnds(lp, i, GLP_DB, lo, up);
       } else {
@@ -109,11 +109,11 @@
 
   void GlpkBase::_eraseColId(int i) {
-    _cols.eraseIndex(i);
-    _cols.shiftIndices(i);
+    cols.eraseIndex(i);
+    cols.shiftIndices(i);
   }
 
   void GlpkBase::_eraseRowId(int i) {
-    _rows.eraseIndex(i);
-    _rows.shiftIndices(i);
+    rows.eraseIndex(i);
+    rows.shiftIndices(i);
   }
 
@@ -557,4 +557,6 @@
   void GlpkBase::_clear() {
     glp_erase_prob(lp);
+    rows.clear();
+    cols.clear();
   }
 
@@ -581,13 +583,4 @@
       break;
     }
-  }
-
-  void GlpkBase::_write(std::string file, std::string format) const
-  {
-    if(format == "MPS")
-      glp_write_mps(lp, GLP_MPS_FILE, 0, file.c_str());
-    else if(format == "LP")
-      glp_write_lp(lp, 0, file.c_str());
-    else throw UnsupportedFormatError(format);
   }
 
@@ -1008,5 +1001,3 @@
   const char* GlpkMip::_solverName() const { return "GlpkMip"; }
 
-
-
 } //END OF NAMESPACE LEMON
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 1336)
+++ lemon/glpk.h	(revision 793)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -26,26 +26,14 @@
 #include <lemon/lp_base.h>
 
+// forward declaration
+#if !defined _GLP_PROB && !defined GLP_PROB
+#define _GLP_PROB
+#define GLP_PROB
+typedef struct { double _opaque_prob; } glp_prob;
+/* LP/MIP problem object */
+#endif
+
 namespace lemon {
 
-  namespace _solver_bits {
-    class VoidPtr {
-    private:
-      void *_ptr;
-    public:
-      VoidPtr() : _ptr(0) {}
-
-      template <typename T>
-      VoidPtr(T* ptr) : _ptr(reinterpret_cast<void*>(ptr)) {}
-
-      template <typename T>
-      VoidPtr& operator=(T* ptr) {
-        _ptr = reinterpret_cast<void*>(ptr);
-        return *this;
-      }
-
-      template <typename T>
-      operator T*() const { return reinterpret_cast<T*>(_ptr); }
-    };
-  }
 
   /// \brief Base interface for the GLPK LP and MIP solver
@@ -56,5 +44,6 @@
   protected:
 
-    _solver_bits::VoidPtr lp;
+    typedef glp_prob LPX;
+    glp_prob* lp;
 
     GlpkBase();
@@ -115,6 +104,4 @@
 
     virtual void _messageLevel(MessageLevel level);
-
-    virtual void _write(std::string file, std::string format) const;
 
   private:
@@ -127,36 +114,23 @@
       }
     };
-
+    
     static FreeEnvHelper freeEnvHelper;
 
   protected:
-
+    
     int _message_level;
-
+    
   public:
 
     ///Pointer to the underlying GLPK data structure.
-    _solver_bits::VoidPtr lpx() {return lp;}
+    LPX *lpx() {return lp;}
     ///Const pointer to the underlying GLPK data structure.
-    _solver_bits::VoidPtr lpx() const {return lp;}
+    const LPX *lpx() const {return lp;}
 
     ///Returns the constraint identifier understood by GLPK.
-    int lpxRow(Row r) const { return _rows(id(r)); }
+    int lpxRow(Row r) const { return rows(id(r)); }
 
     ///Returns the variable identifier understood by GLPK.
-    int lpxCol(Col c) const { return _cols(id(c)); }
-
-#ifdef DOXYGEN
-    /// Write the problem or the solution to a file in the given format
-
-    /// This function writes the problem or the solution
-    /// to a file in the given format.
-    /// Trying to write in an unsupported format will trigger
-    /// \ref LpBase::UnsupportedFormatError.
-    /// \param file The file path
-    /// \param format The output file format.
-    /// Supportted formats are "MPS" and "LP".
-    void write(std::string file, std::string format = "MPS") const {}
-#endif
+    int lpxCol(Col c) const { return cols(id(c)); }
 
   };
Index: lemon/gomory_hu.h
===================================================================
--- lemon/gomory_hu.h	(revision 1270)
+++ lemon/gomory_hu.h	(revision 833)
@@ -1,7 +1,7 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
+/* -*- C++ -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library.
+ * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -28,5 +28,5 @@
 
 /// \ingroup min_cut
-/// \file
+/// \file 
 /// \brief Gomory-Hu cut tree in graphs.
 
@@ -39,5 +39,5 @@
   /// The Gomory-Hu tree is a tree on the node set of a given graph, but it
   /// may contain edges which are not in the original graph. It has the
-  /// property that the minimum capacity edge of the path between two nodes
+  /// property that the minimum capacity edge of the path between two nodes 
   /// in this tree has the same weight as the minimum cut in the graph
   /// between these nodes. Moreover the components obtained by removing
@@ -45,7 +45,7 @@
   /// Therefore once this tree is computed, the minimum cut between any pair
   /// of nodes can easily be obtained.
-  ///
+  /// 
   /// The algorithm calculates \e n-1 distinct minimum cuts (currently with
-  /// the \ref Preflow algorithm), thus it has \f$O(n^3\sqrt{m})\f$ overall
+  /// the \ref Preflow algorithm), thus it has \f$O(n^3\sqrt{e})\f$ overall
   /// time complexity. It calculates a rooted Gomory-Hu tree.
   /// The structure of the tree and the edge weights can be
@@ -61,8 +61,8 @@
 #ifdef DOXYGEN
   template <typename GR,
-            typename CAP>
+	    typename CAP>
 #else
   template <typename GR,
-            typename CAP = typename GR::template EdgeMap<int> >
+	    typename CAP = typename GR::template EdgeMap<int> >
 #endif
   class GomoryHu {
@@ -75,5 +75,5 @@
     /// The value type of capacities
     typedef typename Capacity::Value Value;
-
+    
   private:
 
@@ -90,11 +90,11 @@
     void createStructures() {
       if (!_pred) {
-        _pred = new typename Graph::template NodeMap<Node>(_graph);
+	_pred = new typename Graph::template NodeMap<Node>(_graph);
       }
       if (!_weight) {
-        _weight = new typename Graph::template NodeMap<Value>(_graph);
+	_weight = new typename Graph::template NodeMap<Value>(_graph);
       }
       if (!_order) {
-        _order = new typename Graph::template NodeMap<int>(_graph);
+	_order = new typename Graph::template NodeMap<int>(_graph);
       }
     }
@@ -102,14 +102,14 @@
     void destroyStructures() {
       if (_pred) {
-        delete _pred;
+	delete _pred;
       }
       if (_weight) {
-        delete _weight;
+	delete _weight;
       }
       if (_order) {
-        delete _order;
-      }
-    }
-
+	delete _order;
+      }
+    }
+  
   public:
 
@@ -119,7 +119,7 @@
     /// \param graph The undirected graph the algorithm runs on.
     /// \param capacity The edge capacity map.
-    GomoryHu(const Graph& graph, const Capacity& capacity)
+    GomoryHu(const Graph& graph, const Capacity& capacity) 
       : _graph(graph), _capacity(capacity),
-        _pred(0), _weight(0), _order(0)
+	_pred(0), _weight(0), _order(0) 
     {
       checkConcept<concepts::ReadMap<Edge, Value>, Capacity>();
@@ -135,5 +135,5 @@
 
   private:
-
+  
     // Initialize the internal data structures
     void init() {
@@ -146,5 +146,5 @@
       }
       (*_pred)[_root] = INVALID;
-      (*_weight)[_root] = std::numeric_limits<Value>::max();
+      (*_weight)[_root] = std::numeric_limits<Value>::max(); 
     }
 
@@ -155,25 +155,25 @@
 
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        if (n == _root) continue;
-
-        Node pn = (*_pred)[n];
-        fa.source(n);
-        fa.target(pn);
-
-        fa.runMinCut();
-
-        (*_weight)[n] = fa.flowValue();
-
-        for (NodeIt nn(_graph); nn != INVALID; ++nn) {
-          if (nn != n && fa.minCut(nn) && (*_pred)[nn] == pn) {
-            (*_pred)[nn] = n;
-          }
-        }
-        if ((*_pred)[pn] != INVALID && fa.minCut((*_pred)[pn])) {
-          (*_pred)[n] = (*_pred)[pn];
-          (*_pred)[pn] = n;
-          (*_weight)[n] = (*_weight)[pn];
-          (*_weight)[pn] = fa.flowValue();
-        }
+	if (n == _root) continue;
+
+	Node pn = (*_pred)[n];
+	fa.source(n);
+	fa.target(pn);
+
+	fa.runMinCut();
+
+	(*_weight)[n] = fa.flowValue();
+
+	for (NodeIt nn(_graph); nn != INVALID; ++nn) {
+	  if (nn != n && fa.minCut(nn) && (*_pred)[nn] == pn) {
+	    (*_pred)[nn] = n;
+	  }
+	}
+	if ((*_pred)[pn] != INVALID && fa.minCut((*_pred)[pn])) {
+	  (*_pred)[n] = (*_pred)[pn];
+	  (*_pred)[pn] = n;
+	  (*_weight)[n] = (*_weight)[pn];
+	  (*_weight)[pn] = fa.flowValue();
+	}
       }
 
@@ -182,14 +182,14 @@
 
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        std::vector<Node> st;
-        Node nn = n;
-        while ((*_order)[nn] == -1) {
-          st.push_back(nn);
-          nn = (*_pred)[nn];
-        }
-        while (!st.empty()) {
-          (*_order)[st.back()] = index++;
-          st.pop_back();
-        }
+	std::vector<Node> st;
+	Node nn = n;
+	while ((*_order)[nn] == -1) {
+	  st.push_back(nn);
+	  nn = (*_pred)[nn];
+	}
+	while (!st.empty()) {
+	  (*_order)[st.back()] = index++;
+	  st.pop_back();
+	}
       }
     }
@@ -198,5 +198,5 @@
 
     ///\name Execution Control
-
+ 
     ///@{
 
@@ -208,5 +208,5 @@
       start();
     }
-
+    
     /// @}
 
@@ -233,5 +233,5 @@
     /// Gomory-Hu tree.
     ///
-    /// This function returns the weight of the predecessor edge of the
+    /// This function returns the weight of the predecessor edge of the 
     /// given node in the Gomory-Hu tree.
     /// If \c node is the root of the tree, the result is undefined.
@@ -255,5 +255,5 @@
     ///
     /// This function returns the minimum cut value between the nodes
-    /// \c s and \c t.
+    /// \c s and \c t. 
     /// It finds the nearest common ancestor of the given nodes in the
     /// Gomory-Hu tree and calculates the minimum weight edge on the
@@ -264,13 +264,13 @@
       Node sn = s, tn = t;
       Value value = std::numeric_limits<Value>::max();
-
+      
       while (sn != tn) {
-        if ((*_order)[sn] < (*_order)[tn]) {
-          if ((*_weight)[tn] <= value) value = (*_weight)[tn];
-          tn = (*_pred)[tn];
-        } else {
-          if ((*_weight)[sn] <= value) value = (*_weight)[sn];
-          sn = (*_pred)[sn];
-        }
+	if ((*_order)[sn] < (*_order)[tn]) {
+	  if ((*_weight)[tn] <= value) value = (*_weight)[tn];
+	  tn = (*_pred)[tn];
+	} else {
+	  if ((*_weight)[sn] <= value) value = (*_weight)[sn];
+	  sn = (*_pred)[sn];
+	}
       }
       return value;
@@ -303,21 +303,21 @@
       Node rn = INVALID;
       Value value = std::numeric_limits<Value>::max();
-
+      
       while (sn != tn) {
-        if ((*_order)[sn] < (*_order)[tn]) {
-          if ((*_weight)[tn] <= value) {
-            rn = tn;
+	if ((*_order)[sn] < (*_order)[tn]) {
+	  if ((*_weight)[tn] <= value) {
+	    rn = tn;
             s_root = false;
-            value = (*_weight)[tn];
-          }
-          tn = (*_pred)[tn];
-        } else {
-          if ((*_weight)[sn] <= value) {
-            rn = sn;
+	    value = (*_weight)[tn];
+	  }
+	  tn = (*_pred)[tn];
+	} else {
+	  if ((*_weight)[sn] <= value) {
+	    rn = sn;
             s_root = true;
-            value = (*_weight)[sn];
-          }
-          sn = (*_pred)[sn];
-        }
+	    value = (*_weight)[sn];
+	  }
+	  sn = (*_pred)[sn];
+	}
       }
 
@@ -330,16 +330,16 @@
       std::vector<Node> st;
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        st.clear();
+	st.clear();
         Node nn = n;
-        while (!reached[nn]) {
-          st.push_back(nn);
-          nn = (*_pred)[nn];
-        }
-        while (!st.empty()) {
-          cutMap.set(st.back(), cutMap[nn]);
-          st.pop_back();
-        }
-      }
-
+	while (!reached[nn]) {
+	  st.push_back(nn);
+	  nn = (*_pred)[nn];
+	}
+	while (!st.empty()) {
+	  cutMap.set(st.back(), cutMap[nn]);
+	  st.pop_back();
+	}
+      }
+      
       return value;
     }
@@ -350,5 +350,5 @@
 
     /// Iterate on the nodes of a minimum cut
-
+    
     /// This iterator class lists the nodes of a minimum cut found by
     /// GomoryHu. Before using it, you must allocate a GomoryHu class
@@ -443,9 +443,9 @@
       }
     };
-
+    
     friend class MinCutEdgeIt;
-
+    
     /// Iterate on the edges of a minimum cut
-
+    
     /// This iterator class lists the edges of a minimum cut found by
     /// GomoryHu. Before using it, you must allocate a GomoryHu class
@@ -480,5 +480,5 @@
           }
       }
-
+      
     public:
       /// Constructor
@@ -549,5 +549,5 @@
       }
       /// Postfix incrementation
-
+      
       /// Postfix incrementation.
       ///
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 1340)
+++ lemon/graph_to_eps.h	(revision 833)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -26,5 +26,5 @@
 #include<vector>
 
-#ifndef LEMON_WIN32
+#ifndef WIN32
 #include<sys/time.h>
 #include<ctime>
@@ -223,4 +223,5 @@
   using T::_copyright;
 
+  using T::NodeTextColorType;
   using T::CUST_COL;
   using T::DIST_COL;
@@ -675,5 +676,5 @@
     {
       os << "%%CreationDate: ";
-#ifndef LEMON_WIN32
+#ifndef WIN32
       timeval tv;
       gettimeofday(&tv, 0);
@@ -684,7 +685,7 @@
 #else
       os << bits::getWinFormattedDate();
-      os << std::endl;
 #endif
     }
+    os << std::endl;
 
     if (_autoArcWidthScale) {
